import unittest

import numpy
from namevariable import WesternName


class TestName(unittest.TestCase):
    def test_household(self):
        name = WesternName("foo")
        numpy.testing.assert_almost_equal(
            name.comparator("James and Rita Allen", "Rita and James Allen"),
            [
                1,
                0,
                1,
                1,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0.5,
                0,
                0,
                0,
                0.5,
                0,
                0,
                0,
                0.5,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                1,
                0,
                0,
                0,
                1,
                0,
                0,
                0,
                1,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
            ],
        )

    def test_person_type(self):
        name = WesternName("foo", name_type="person")
        print(name.comparator("James and Rita Allen", "Rita and James Allen"))

        numpy.testing.assert_almost_equal(
            name.comparator("James and Rita Allen", "Rita and James Allen"),
            [
                1,
                0,
                1,
                1,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0.5,
                0,
                0,
                0,
                0.5,
                0,
                0,
                0,
                0.5,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                1,
                0,
                0,
                0,
                1,
                0,
                0,
                0,
                1,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
            ],
        )

    def test_company_type(self):
        name = WesternName("foo", name_type="company")
        print(name.comparator("James and Rita Allen", "Rita and James Allen"))

        numpy.testing.assert_almost_equal(
            name.comparator("James and Rita Allen", "Rita and James Allen"),
            [
                1,
                0,
                1,
                3.15625,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                1,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
            ],
        )


def prettyPrint(variable, comparison):
    for e in zip(variable.higher_vars, comparison):
        print("%s:\t %s" % e)
